package ch.zhaw.ads;

import java.util.LinkedList;
import java.util.List;

public class RankingListServer implements CommandExecutor {

    public List<Competitor> createList(String rankingText) {
        List<Competitor> competitorList = new LinkedList<>();
        for(String listEntry : rankingText.split("\\n")){
            String[] entry = listEntry.split(";");
            competitorList.add(new Competitor(0, entry[0], entry[1]));
        }
        competitorList.sort(new AlphaComparatorCompetitor());
        int rank = 1;
        for(Competitor competitor : competitorList){
            competitor.setRank(rank);
            rank++;
        }
        return competitorList;
    }

    public String createSortedText(List<Competitor> competitorList) {
        // TODO Implement
        StringBuilder stringBuilder = new StringBuilder();
        int rank = 1;
        for (Competitor competitor : competitorList) {
            stringBuilder.append(rank).append(" ").append(competitor.getName()).append(" ").append(competitor.getTime()).append("\n");
            rank++;
        }
        return stringBuilder.toString();
    }

    public String createNameList(List<Competitor> competitorList) {
        // TODO Implement
        return "";
    }

    public String execute(String rankingList) {
        List<Competitor> competitorList = createList(rankingList);
        return "Rangliste\n" + createSortedText(competitorList);
    }
}
